--1, 2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31
-- GrimHarvest_ExtraBoss
-- 0, 1, 2, 4, 6, 10, 12
-- GrimHarvest_ExtraMobs
-- 0, 1, 2, 4, 6, 10, 12
-- GrimHarvest_BossRespawn
-- 0, 1, 2, 4, 6, 10, 12, 16, 18, 22, 28, 30
gd.GrimHarvest = {}

local chest_tier2_id = nil
local chest_tier2_unlocked_id = nil
local chest_loghorrean = nil
local chest_teodin = nil
local chest_korvaak = nil
local chest_kraken = nil
local chest_SoT = nil
local chest_BoC = nil
local chest_PV = nil
local chest_AG = nil
local chest_TofH = nil


local values = {0, 1, 2, 4, 6, 10, 12, 16, 18, 22, 28, 30}
local GH_Extra_Mobs = "Grim_Harvest_Extra_Mobs_"
local GH_Extra_Boss = "Grim_Harvest_Extra_Boss_"
local GH_Extra_Respawn = "Grim_Harvest_Extra_Respawn_"

gd.GrimHarvest.AdditionalCrowdSpawn = 0
gd.GrimHarvest.AdditionalBossSpawn = 0
gd.GrimHarvest.AdditionalBossRespawns = 0
gd.GrimHarvest.killTreshold = 0
gd.GrimHarvest.ProxieSpawned = {}
gd.GrimHarvest.TargetFarmRecord = ""

gd.GrimHarvest.killTable = {
	quill = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_ratminibossa01.dbr",
		count = 0,
		quest = nil
	},
	kyrogg = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_reanimatora01.dbr",
		count = 0,
		quest = function(id) gd.quests.devilsCrossingQuestReanimator.killReanimatorGlobalMP(id) end
	},
	viloth = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_vilotha01.dbr",
		count = 0,
		quest = function(id) gd.quests.devilsCrossingQuestWaterpump.vilothKilled(id) end
	},
	shambler = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_golema01.dbr",
		count = 0,
		quest = function(id) gd.quests.devilsCrossingQuestBurrwitch.golemKilled(id) end
	},
	ellena = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_slithlab_slitha01.dbr",
		count = 0,
		quest = function(id)
			gd.quests.devilsCrossingQuestSlithLab.bossDoorOpen(id)
			gd.GrimHarvest.MultiplyChest("ellena", chest_tier2_unlocked_id, "grim_harvest/records/items/lootchests/d03_bosschest_unlocked.dbr")
		end
	},
	primordian = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_wightmire_slitha01.dbr",
		count = 0,
		quest = nil
	},
	salazar = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_cultistdungeona01.dbr",
		count = 0,
		quest = function(id) gd.quests.wightmireCultistCellar.bossDoorOpen(id) end
	},
	gutworm = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_smugglerbasina01.dbr",
		count = 0,
		quest = function()
			gd.GrimHarvest.MultiplyChest("gutworm", chest_tier2_id, "grim_harvest/records/items/lootchests/d03_bosschest.dbr")
		end
	},
	grundleplith = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_ratminibossa02.dbr",
		count = 0,
		quest = nil
	},
	krieg = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_wardena01.dbr",
		count = 0,
		quest = function(id) gd.quests.devilsCrossingQuestWarden.wardenKilled(id) end
	},
	milton = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_miltonharta01.dbr",
		count = 0,
		quest = nil
	},
	narbalgal = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_burrwitchoutskirts_grobleshamana01.dbr",
		count = 0,
		quest = nil
	},
	rolderathis = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_floodedpassage_ruina01.dbr",
		count = 0,
		quest = nil
	},
	guardianOfDreeg = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_witchgodguardian_dreeg.dbr",
		count = 0,
		quest = nil
	},
	balegor = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_swamp_swamptroll_king_a01.dbr",
		count = 0,
		quest = nil
	},
	kalisKa = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_swamp_rifthound_bone_a01.dbr",
		count = 0,
		quest = nil
	},
	sentinel = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_witchgodguardian_templeboss.dbr",
		count = 0,
		quest = function(id) gd.quests.devilsCrossingWitchGodShrines.bossKilled(id) end
	},
	UroGuard = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_uroboruuk_guardian.dbr",
		count = 0,
		quest = nil
	},
	Balros = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_fleshandiron_mutant01.dbr",
		count = 0,
		quest = function(id) gd.quests.devilsCrossingQuestZombies.mutant01Killed(id) end
	},
	Hagra = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_fleshandiron_mutant02.dbr",
		count = 0,
		quest = function(id) gd.quests.devilsCrossingQuestZombies.mutant02Killed(id) end
	},
	Abaddoth = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_chthoniccultist_burrwitchcathderal.dbr",
		count = 0,
		quest = nil
	},
	Galeslice = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_dranghoul_eastmarsh.dbr",
		count = 0,
		quest = nil
	},
	baros = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_areab_brokenhills_cavea01.dbr",
		count = 0,
		quest = nil
	},
	nicholas = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_areab_arkovianfoothills_cavea01.dbr",
		count = 0,
		quest = nil
	},
	ronaprax = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_areab_oldarkovia_waspa02.dbr",
		count = 0,
		quest = nil
	},
	boris = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_areab_oldarkovia_pitmaster.dbr",
		count = 0,
		quest = nil
	},
	halion = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_areab_oldarkovia_minea01.dbr",
		count = 0,
		quest = nil
	},
	direni = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_direni.dbr",
		count = 0,
		quest = function(id) gd.quests.devilsCrossingQuestLostJournal.direniDoorOpen(id) end
	},
	martin = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_areab_arkovianfoothills_minea01.dbr",
		count = 0,
		quest = function(id) gd.quests.homesteadQuestRemoveTheHead.martinKilled(id) end
	},
	darius = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_daius.dbr",
		count = 0,
		quest = function(id) gd.quests.homesteadQuestRemoveTheHead.dariusKilled(id) end
	},
	ulraprax = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_areab_oldarkovia_waspa01.dbr",
		count = 0,
		quest = nil
	},
	nomos = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_oligarch_ghost01.dbr",
		count = 0,
		quest = function(id) gd.quests.homesteadQuestNecromancer.oligarchOneKilled(id) end
	},
	laudos = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_oligarch_ghost02.dbr",
		count = 0,
		quest = function(id) gd.quests.homesteadQuestNecromancer.oligarchTwoKilled(id) end
	},
	rhovena = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_oligarch_ghost03.dbr",
		count = 0,
		quest = function(id) gd.quests.homesteadQuestNecromancer.oligarchThreeKilled(id) end
	},
	kilrian = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_areab_oldarkovia_ruina01.dbr",
		count = 0,
		quest = function(id) gd.quests.homesteadQuestOldArkovia.bossKilled(id) end
	},
	guardianOfSolael = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_witchgodguardian_solael.dbr",
		count = 0,
		quest = nil
	},
	Zarthuzellan = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_areab_brokenhills_ruina01.dbr",
		count = 0,
		quest = function(id) gd.quests.homesteadStepsOfTormentBosses.grandPriestKilled(id) end
	},
	Ilgorr = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_areab_stepsoftorment_skeletalgolem01.dbr",
		count = 0,
		quest = function(id) gd.quests.homesteadStepsOfTormentBosses.Boss1DoorOpen(id) end
	},
	Alkamos = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_areab_stepsoftorment_ghost01.dbr",
		count = 0,
		quest = function(id)
			gd.quests.homesteadStepsOfTormentBosses.Boss2Killed(id)
			gd.GrimHarvest.MultiplyChest("Alkamos", chest_SoT, "grim_harvest/records/items/lootchests/d06_bosschest_stepsoftorment.dbr")
		end
	},
	Karnath = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_skeletalgolem_arkoviancolisseum.dbr",
		count = 0,
		quest = nil
	},
	NarenKur = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_skeletalknight_arkovianruins.dbr",
		count = 0,
		quest = nil
	},
	voldrak = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_troll_smugglerpass_01.dbr",
		count = 0,
		quest = function(id) gd.quests.homesteadQuestWeNeedFood.trollKilled(id) end
	},
	ikrix = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_areac_prawncave_mountaindeeps_a01.dbr",
		count = 0,
		quest = nil
	},
	harrath = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_bounty17.dbr",
		count = 0,
		quest = nil
	},
	heraldflame = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_areac_aetherialharbinger_01.dbr",
		count = 0,
		quest = function(id) gd.homesteadRepairs.heraldOfFlameKilled(id) end
	},
	Inixil = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_areac_dermapteranvizier_a02.dbr",
		count = 0,
		quest = nil
	},
	Lozakal = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_areac_dermapteranvizier_a01.dbr",
		count = 0,
		quest = nil
	},
	ravna = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_areac_dermapteranqueen_a01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaCQuestInfestedFields.queenKilled(id) end
	},
	gollus = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_areac_trollhalf_gollus_a03.dbr",
		count = 0,
		quest = function()
			gd.GrimHarvest.MultiplyChest("gollus", chest_tier2_id, "grim_harvest/records/items/lootchests/d03_bosschest.dbr")
		end
	},
	amalgamation = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_areac_aetherialabomination_a01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaCQuestAetherialFarm.abominationKilled(id) end
	},
	mogara = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_areac_manticore_jaggedwastea01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaCQuestBlackLegionHunts.manticoreKilled(id) end
	},
	bloodbriar = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_areac_thornedhorror_jaggedwaste_a01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaCQuestBlackLegionHunts.thornedHorrorKilled(id) end
	},
	ungoliax = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_areac_spidercave_mountaindeeps_a01ambush.dbr",
		count = 0,
		quest = function(id) gd.quests.areaCQuestBlackLegionHunts.spiderKilled(id) end
	},
	bloodfeast = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_areac_dranghoul_jaggedwaste_a01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaCQuestBlackLegionHunts.dranghoulKilled(id) end
	},
	sorrow = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_ghost_maninneed_01.dbr",
		count = 0,
		quest = nil
	},
	bolvar = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_areac_cultistcaptain_a01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaCQuestZealots.captain01Killed(id) end
	},
	zaria = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_areac_cultistcaptain_a02.dbr",
		count = 0,
		quest = function(id) gd.quests.areaCQuestZealots.captain02Killed(id) end
	},
	karroz = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_areac_cultistsummoner_a01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaCQuestBloodHarvest.cultistSummonerKilled(id) end
	},
	venarius = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_bloodgrove_fleshhulk_quarrya01.dbr",
		count = 0,
		quest = nil
	},
	bravna = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_areac_zealotcaptain_a01.dbr",
		count = 0,
		quest = nil
	},
	ravok = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_areac_necrocaptain_a01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaCQuestZealots.necroBossKilled(id) end
	},
	HeraldStars = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_aread_aetherialroguelike_aetherialharbinger_03.dbr",
		count = 0,
		quest = function(id) gd.quests.areaDPortValburyBosses.doorGuardianKilled(id) end
	},
	Ordas = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_aread_aetherialroguelike_watcher_02.dbr",
		count = 0,
		quest = nil
	},
	Ygraad = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_aread_aetherialroguelike_watcher_01.dbr",
		count = 0,
		quest = nil
	},
	Brandis = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_aread_aetherialroguelike_watcher_03.dbr",
		count = 0,
		quest = nil
	},
	Jarren = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_aread_aetherialroguelike_fleshhulk_01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaDPortValburyBosses.Boss1Killed(id) end
	},
	Thelon = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_outcast_target.dbr",
		count = 0,
		quest = nil
	},
	RagNadar = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_areac_chthoniandevourer_chthonicvoid_01.dbr",
		count = 0,
		quest = nil
	},
	HeraldDestruction = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_areac_aetherialharbinger_02.dbr",
		count = 0,
		quest = function(id) gd.quests.areaCQuestLegionPriority.bossKilled(id) end
	},
	PortValburyTrio = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_aread_aetherialroguelike_reanimatormain.dbr",
		count = 0,
		quest = function(id)
			gd.quests.areaDPortValburyBosses.Boss2AKilled(id)
			gd.quests.areaDPortValburyBosses.Boss2BKilled(id)
			gd.quests.areaDPortValburyBosses.Boss2CKilled(id)
			gd.GrimHarvest.MultiplyChest("PortValburyTrio", chest_PV, "grim_harvest/records/items/lootchests/d06_bosschest_portvalbury.dbr")
		end
	},
	Rutnick = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_outlaw_arkovianruins.dbr",
		count = 0,
		quest = nil
	},
	Ragrathar = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_aread_yeti_asterkarnmountains_01.dbr",
		count = 0,
		quest = nil
	},
	Nagrathar = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_aread_ghoul_factioncrypt_01.dbr",
		count = 0,
		quest = nil
	},
	Barthollem = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_zealot_boss02.dbr",
		count = 0,
		quest = function(id) gd.areaCFactionBattle.zealotBossKilled(id) end
	},
	Malkadarr = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_necro_boss02.dbr",
		count = 0,
		quest = function(id) gd.areaCFactionBattle.necroBossKilled(id) end
	},
	Lucius = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_aread_aetherialcommander_a01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaDQuestTrueThreat.bossKilled(id) end
	},
	Loxmere = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_aread_loxmerenightmage01.dbr",
		count = 0,
		quest = nil
	},
	Plagius = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_aread_ghoul_necropolis_01.dbr",
		count = 0,
		quest = nil
	},
	Thalonis = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_aread_cultistleader_a01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaDQuestBaneOfCairn.cultistBossKilled(id) end
	},
	Galgalor = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_aread_chthonianleech_necropolis_01.dbr",
		count = 0,
		quest = nil
	},
	GuardianOfBysmiel = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_witchgodguardian_bysimel.dbr",
		count = 0,
		quest = nil
	},
	MadQueen = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_witchgod_madqueen.dbr",
		count = 0,
		quest = function(id) gd.quests.devilsCrossingWitchGodShrines.secretBossKilled(id) end
	},
	BalokAnatu = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_aread_chthonianleech_void01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaDBastionOfChaosBosses.doorGuardianKilled(id) end
	},
	LagothAk = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_aread_chthonianroguelike_minion01.dbr",
		count = 0,
		quest = nil
	},
	SharZul = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_aread_chthonianroguelike_dreadguard01.dbr",
		count = 0,
		quest = function(id)
			gd.quests.areaDBastionOfChaosBosses.Boss2Killed(id)
			gd.GrimHarvest.MultiplyChest("SharZul", chest_BoC, "grim_harvest/records/items/lootchests/d06_bosschest_bastionofchaos.dbr")
		end
	},
	BaneGargoth = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_areac_obsidiandefiler_chthonicvoid_01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaDQuestBaneOfCairn.obsidianThroneBossKilled(id) end
	},
	Harvoul = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_aread_ghoul_kymoncrypt_01.dbr",
		count = 0,
		quest = nil
	},
	Sharanatu = {
		dbr = "grim_harvest/records/proxies/boss&quest/questproxy_zealot_kymonsecret.dbr",
		count = 0,
		quest = function(id) gd.quests.areaCQuestZealots.bossKilled(id) end
	},
	Harak = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_aread_bastionofchaos_gauntletguardian02.dbr",
		count = 0,
		quest = function(id) gd.quests.areaDBastionOfChaosChallenges.gauntletGuardian01Killed(id) end
	},
	Anasteria = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_outcast_01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaDQuestExile.exileKilled(id) end
	},
	AnasteriaHarbinger = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_outcast_02.dbr",
		count = 0,
		quest = function(id) gd.quests.areaDQuestExile.exileKilled(id) end
	},
	AnasteriaWrath = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_outcast_03.dbr",
		count = 0,
		quest = function(id) gd.quests.areaDQuestExile.exileKilled(id) end
	},
	Loghorrean = {
		dbr = "grim_harvest/records/proxies/boss&quest/proxy_loghorean.dbr",
		count = 0,
		quest = function(id)
			gd.quests.areaDQuestBaneOfCairn.loghorreanKilled(id)
			gd.GrimHarvest.MultiplyChest("Loghorrean", chest_loghorrean, "grim_harvest/records/items/lootchests/d04_bosschest_loghorrean.dbr")
		end
	},
	Dralgar = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_introaetherial.dbr",
		count = 0,
		quest = nil
	},
	Avris = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_humanwendigo_01.dbr",
		count = 0,
		quest = nil
	},
	Carraxus = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/questproxy_areae_darkwood_crab.dbr",
		count = 0,
		quest = nil
	},
	Packla = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_cannibal_01.dbr",
		count = 0,
		quest = nil
	},
	Janaxia = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_witchwendigo.dbr",
		count = 0,
		quest = function(id) gd.quests.areaEQuestFactionWitch.witchBetrayerOnKill(id) end
	},
	Bargoll = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_swampgolem_01.dbr",
		count = 0,
		quest = nil
	},
	Ragarroth = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_roguelike_manticore.dbr",
		count = 0,
		quest = function(id) gd.quests.areaEAncientGroveBosses.doorGuardianKilled(id) end
	},
	Gulgazor = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_roguelike_swampcrab_01.dbr",
		count = 0,
		quest = nil
	},
	Slathsarr = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_roguelike_basilisk.dbr",
		count = 0,
		quest = function(id) gd.quests.areaEAncientGroveBosses.Boss1Killed(id) end
	},
	Vilgazor = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_roguelike_swampcrab_02.dbr",
		count = 0,
		quest = nil
	},
	Deathstalker = {
		dbr = "grim_harvest/records/proxies/special/proxy_ancientgrove_deathstalker.dbr",
		count = 0,
		quest = nil
	},
	Gargabol = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_roguelike_swampgolem.dbr",
		count = 0,
		quest = function(id)
			gd.quests.areaEAncientGroveBosses.Boss2Killed(id)
			gd.GrimHarvest.MultiplyChest("Gargabol", chest_AG, "grim_harvest/records/items/lootchests/d06_bosschest_beastroguelike.dbr")
		end
	},
	Kraval = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_kraken.dbr",
		count = 0,
		quest = function(id)
			gd.quests.areaEQuestUgdenbog.krakenKilled(id)
			gd.GrimHarvest.MultiplyChest("Kraval", chest_kraken, "grim_harvest/records/items/lootchests/d04_bosschest_kraken.dbr")
		end
	},
	Sylvarria = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_livingplant.dbr",
		count = 0,
		quest = function(id) gd.quests.areaEQuestFactionWitch.sylvarriaOnKill(id) end
	},
	Ugdall = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_wraith_01.dbr",
		count = 0,
		quest = nil
	},
	Naxen = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_crab_mineboss.dbr",
		count = 0,
		quest = nil
	},
	Larria = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_witchcoven.dbr",
		count = 0,
		quest = function(id) gd.quests.areaEQuestFactionWendigo.witchOnKill(id) end
	},
	Handarroth = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_wendigo_01.dbr",
		count = 0,
		quest = nil
	},
	Ollivioth = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_wendigo_02.dbr",
		count = 0,
		quest = nil
	},
	Yulovoth = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_wendigo_03.dbr",
		count = 0,
		quest = nil
	},
	EkketZul = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/questproxy_areae_chthonianrylok_01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaEQuestVoid.ulgrimBossKilled(id) end
	},
	Namadea = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/questproxy_areae_wendigo.dbr",
		count = 0,
		quest = nil
	},
	Rakka = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areaf_trapchest_01.dbr",
		count = 0,
		quest = nil
	},
	Gabal = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areae_chthonianrylok_01.dbr",
		count = 0,
		quest = nil
	},
	Bandragos = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areaf_dravisboss_01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaFNPCDaila.killedBoss(id) end
	},
	Lunal = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/questproxy_areae_chthonianservitor_01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaEQuestVoid.servitorBossOnKill(id) end
	},
	Terrnox = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areaf_humanascendant_01.dbr",
		count = 0,
		quest = nil
	},
	Galakros = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areaf_aetherialcolossus_01.dbr",
		count = 0,
		quest = nil
	},
	Bollag = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/questproxy_areaf_gatekeeper.dbr",
		count = 0,
		quest = function(id) gd.quests.areaFQuestMalmouthBridge.unlockLever(id) end
	},
	Hinissius = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areaf_aetherialfleshshaper_01.dbr",
		count = 0,
		quest = nil
	},
	Haraxis = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/questproxy_areaf_fleshweaverharaxis.dbr",
		count = 0,
		quest = nil
	},
	Valaxteria = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areaf_humanascendant_02.dbr",
		count = 0,
		quest = nil
	},
	Allostria = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/questproxy_areaf_mindthief.dbr",
		count = 0,
		quest = nil
	},
	FleshKrieg = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/questproxy_areaf_fleshweaverkrieg.dbr",
		count = 0,
		quest = function(id) gd.quests.areaFQuestMalmouthFactory.kriegKilled(id) end
	},
	Hagalvar = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areaf_factoryguardian_01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaFQuestMalmouthFactory.killGuardian01(id) end
	},
	Rodalgar = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areaf_factoryguardian_02.dbr",
		count = 0,
		quest = function(id) gd.quests.areaFQuestMalmouthFactory.killGuardian02(id) end
	},
	Theodin = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/questproxy_areaf_finalboss.dbr",
		count = 0,
		quest = function(id)
			gd.quests.areaFFleshshaper.bossPhase03Killed(id)
			gd.GrimHarvest.MultiplyChest("Theodin", chest_teodin, "grim_harvest/records/items/lootchests/d04_bosschest_fleshshaper.dbr")
		end
	},
	Blugrug = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_aetherialbloater_malmouthdocks.dbr",
		count = 0,
		quest = nil
	},
	Council = {
		dbr = "grim_harvest/records/proxies/boss&questgdx1/proxy_areaf_enclavesidebosses_01.dbr",
		count = 0,
		quest = function(id)
			gd.quests.areaFQuestFactionMalmouth.enclaveBoss01OnKill(id)
			gd.quests.areaFQuestFactionMalmouth.enclaveBoss02OnKill(id)
			gd.quests.areaFQuestFactionMalmouth.enclaveBoss03OnKill(id)
			gd.GrimHarvest.MultiplyChest("Council", chest_tier2_unlocked_id, "grim_harvest/records/items/lootchests/d03_bosschest_unlocked.dbr")
		end
	},
	Margul = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_beetlemaggot.dbr",
		count = 0,
		quest = nil
	},
	Ramzul = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_osyrmummy.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGMiscEncounters.mummyOsyrOnKill(id) end
	},
	Titanovore = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_lizarddesertboss.dbr",
		count = 0,
		quest = nil
	},
	Tirgan = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_boundspiritsboss.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGThreeBrothers.madPriestKill(id) end
	},
	Durg = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_beetledesert.dbr",
		count = 0,
		quest = nil
	},
	Navan = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_dreegusurper.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGDreegQuests.dreegUsurperOnKill(id) end
	},
	GannarVakkar = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_scorpiondesert.dbr",
		count = 0,
		quest = nil
	},
	Ishtal = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_dreegmindreaper.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGDreegQuests.dreegDCBossKill(id) end
	},
	Grimmaw = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_eldritchhound_basalt.dbr",
		count = 0,
		quest = nil
	},
	Crimson = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_korvaaklieutenant_02.dbr",
		count = 0,
		quest = nil
	},
	Duskreaper = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_duskreaper.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGSQPreemptiveStrike.bossKill(id) end
	},
	Okalot = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_themessenger.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGSQKorvaakMessenger.messengerOnKill(id) end
	},
	Azaleon = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_gryphontempleboss.dbr",
		count = 0,
		quest = nil
	},
	Dravis = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_dravis.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGTombOfKorvaak.DravisKilled(id) end
	},
	Steward = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_steward.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGTombOfKorvaak.tombGuardKilled(id) end
	},
	Segarius = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_korvaaklieutenant_01.dbr",
		count = 0,
		quest = nil
	},
	Inarah = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_inarah.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGDreegFaction.madWitchKill(id) end
	},
	Kymon = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/questproxy_areag_fatherkymon.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGFatherKymon.kymonKilled(id) end
	},
	Korvaak = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/questproxy_areag_korvaakfinal.dbr",
		count = 0,
		quest = function(id)
			gd.quests.areaGKorvaak.bossPhase03Finished(id)
			gd.GrimHarvest.MultiplyChest("Korvaak", chest_korvaak, "grim_harvest/records/items/lootchests/d04_bosschest_korvaak.dbr")
		end
	},
	Galfang = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_bysmielfiend.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGBysmielQuests.OpenShortcutRift(id) end
	},
	Ketan = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_ketan.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGBysmielQuests.BloodswornChthonianOnKill(id) end
	},
	Inashkor = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_stonegryphon_templeguardian.dbr",
		count = 0,
		quest = function(id)
			gd.quests.areaGBysmielQuests.guardian01OnKill(id)
			gd.quests.areaGBysmielQuests.guardian02OnKill(id)
			gd.quests.areaGBysmielQuests.guardian03OnKill(id)
		end
	},
	Onarix = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_solaelfiend.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGSolaelQuests.OpenShortcutRift(id) end
	},
	Belloq = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_solaelfaction.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGSolaelFaction.solaelStatueGuardianBossKilled(id) end
	},
	MRP1 = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_map_protector_2.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGSolaelFaction.solaelStatueGuardian01Killed(id) end
	},
	MRP2 = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_map_protector_3.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGSolaelFaction.solaelStatueGuardian02Killed(id) end
	},
	Jarinthor = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_riggsquest_guardian_01.dbr",
		count = 0,
		quest = nil
	},
	Hallanx = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_riggsquest_guardian_02.dbr",
		count = 0,
		quest = nil
	},
	Gurblix = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_riggsquest_maggot_01.dbr",
		count = 0,
		quest = nil
	},
	Keeper = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_roguelike_gatekeeper.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGTombOfHereticBosses.doorGuardianKilled(id) end
	},
	Morgoneth = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_roguelike_finalboss.dbr",
		count = 0,
		quest = function(id)
			gd.quests.areaGTombOfHereticBosses.Boss2Killed(id)
			gd.GrimHarvest.MultiplyChest("Morgoneth", chest_TofH, "grim_harvest/records/items/lootchests/d06_bosschest_tombroguelike.dbr")
		end
	},
	Sethris = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_eldritcharmor_roguelikemagi_01.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGTombOfHereticBosses.Magi1Killed(id) end
	},
	Orissia = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_eldritcharmor_roguelikemagi_02.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGTombOfHereticBosses.Magi2Killed(id) end
	},
	Anubar = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_eldritcharmor_roguelikemagi_03.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGTombOfHereticBosses.Magi3Killed(id) end
	},
	Tawrot = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_eldritcharmor_roguelikemagi_04.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGTombOfHereticBosses.Magi4Killed(id) end
	},
	Basti = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_eldritcharmor_roguelikemagi_05.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGTombOfHereticBosses.Magi5Killed(id) end
	},
	Shuroth = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_eldritcharmor_roguelikemagi_06.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGTombOfHereticBosses.Magi6Killed(id) end
	},
	Khonsar = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_eldritcharmor_roguelikemagi_07.dbr",
		count = 0,
		quest = function(id) gd.quests.areaGTombOfHereticBosses.Magi7Killed(id) end
	},
	ScionHunger1 = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_roguelike_monstrosity_amb_01.dbr",
		count = 0,
		quest = nil
	},
	ScionHunger2 = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_roguelike_monstrosity_amb_02.dbr",
		count = 0,
		quest = nil
	},
	ScionHunger3 = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_roguelike_monstrosity_amb_02.dbr",
		count = 0,
		quest = nil
	},
	ScionHunger4 = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_roguelike_monstrosity_amb_04.dbr",
		count = 0,
		quest = nil
	},
	ScionHunger5 = {
		dbr = "grim_harvest/records/proxies/areag/celestialleech_n.dbr",
		count = 0,
		quest = nil
	},
	ScionFamine1 = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_roguelike_monstrosity_gauntlet_amb_01.dbr",
		count = 0,
		quest = nil
	},
	ScionFamine2 = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_roguelike_monstrosity_gauntlet_amb_02.dbr",
		count = 0,
		quest = nil
	},
	Astros = {
		dbr = "grim_harvest/records/proxies/boss&questgdx2/proxy_areag_kovaakchosen_sunspire.dbr",
		count = 0,
		quest = nil
	},
	Valdaran = {
		dbr = "records/creatures/enemies/nemesis/nemesis_aetherial_01.dbr",
		count = 0,
		chest = {"grim_harvest/records/items/lootchests/n01_nemesischest_aetherial01.dbr","grim_harvest/records/items/lootchests/n01_nemesischest_aetherial02.dbr","grim_harvest/records/items/lootchests/n01_nemesischest_aetherial03.dbr"},
		quest = function(id)
			gd.nemesis.aetherialNemesisKilled(id)
			gd.GrimHarvest.MultiplyChest("Valdaran", id, gd.GrimHarvest.killTable["Valdaran"].chest[1 + Game.GetGameDifficulty()])
		end
	},
	Fabius = {
		dbr = "records/creatures/enemies/nemesis/nemesis_outlaw_01.dbr",
		count = 0,
		chest = {"grim_harvest/records/items/lootchests/n01_nemesischest_outlaw01.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_outlaw02.dbr","grim_harvest/records/items/lootchests/n01_nemesischest_outlaw03.dbr"},
		quest = function(id)
			gd.nemesis.outlawNemesisKilled(id)
			gd.GrimHarvest.MultiplyChest("Fabius", id, gd.GrimHarvest.killTable["Fabius"].chest[1 + Game.GetGameDifficulty()])
		end
	},
	Zantarin = {
		dbr = "records/creatures/enemies/nemesis/nemesis_orderdeathsvigil_01.dbr",
		count = 0,
		chest = {"grim_harvest/records/items/lootchests/n01_nemesischest_orderdeathvigil01.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_orderdeathvigil02.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_orderdeathvigil03.dbr"},
		quest = function(id)
			gd.nemesis.orderDeathVigilNemesisKilled(id)
			gd.GrimHarvest.MultiplyChest("Zantarin", id, gd.GrimHarvest.killTable["Zantarin"].chest[1 + Game.GetGameDifficulty()])
		end
	},
	Moosilauke = {
		dbr = "records/creatures/enemies/nemesis/nemesis_undead_02a.dbr",
		count = 0,
		chest = {"grim_harvest/records/items/lootchests/n01_nemesischest_undead01.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_undead02.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_undead03.dbr"},
		quest = function(id)
			gd.nemesis.undeadNemesisKilled(id)
			gd.GrimHarvest.MultiplyChest("Moosilauke", id, gd.GrimHarvest.killTable["Moosilauke"].chest[1 + Game.GetGameDifficulty()])
		end
	},
	BennJahr = {
		dbr = "records/creatures/enemies/nemesis/nemesis_chthonian_02.dbr",
		count = 0,
		chest = {"grim_harvest/records/items/lootchests/n01_nemesischest_chthonian01.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_chthonian02.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_chthonian03.dbr"},
		quest = function(id)
			gd.nemesis.chthonianNemesisKilled(id)
			gd.GrimHarvest.MultiplyChest("BennJahr", id, gd.GrimHarvest.killTable["BennJahr"].chest[1 + Game.GetGameDifficulty()])
		end
	},
	IronMaiden = {
		dbr = "records/creatures/enemies/nemesis/nemesis_kymon_02.dbr",
		count = 0,
		chest = {"grim_harvest/records/items/lootchests/n01_nemesischest_kymonchosen01.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_kymonchosen02.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_kymonchosen03.dbr"},
		quest = function(id)
			gd.nemesis.kymonChosenNemesisKilled(id)
			gd.GrimHarvest.MultiplyChest("IronMaiden", id, gd.GrimHarvest.killTable["IronMaiden"].chest[1 + Game.GetGameDifficulty()])
		end
	},
	Aleksander = {
		dbr = "records/creatures/enemies/nemesis/nemesis_aetherialvanguard_01.dbr",
		count = 0,
		chest = {"grim_harvest/records/items/lootchests/n01_nemesischest_aetherialvanguard01.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_aetherialvanguard02.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_aetherialvanguard03.dbr"},
		quest = function(id)
			gd.nemesisGDX1.aetherialVanguardNemesisKilled(id)
			gd.GrimHarvest.MultiplyChest("Aleksander", id, gd.GrimHarvest.killTable["Aleksander"].chest[1 + Game.GetGameDifficulty()])
		end
	},
	Reaper = {
		dbr = "records/creatures/enemies/nemesis/nemesis_wendigo_01.dbr",
		count = 0,
		chest = {"grim_harvest/records/items/lootchests/n01_nemesischest_wendigo01.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_wendigo02.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_wendigo03.dbr"},
		quest = function(id)
			gd.nemesisGDX1.wendigoNemesisKilled(id)
			gd.GrimHarvest.MultiplyChest("Reaper", id, gd.GrimHarvest.killTable["Reaper"].chest[1 + Game.GetGameDifficulty()])
		end
	},
	Grava = {	dbr = "records/creatures/enemies/nemesis/nemesis_chthonianvoidborn_01.dbr",
		count = 0,
		chest = {"grim_harvest/records/items/lootchests/n01_nemesischest_chthonianvoidborn01.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_chthonianvoidborn02.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_chthonianvoidborn03.dbr"},
		quest = function(id)
			gd.nemesisGDX1.chthonianVoidbornNemesisKilled(id)
			gd.GrimHarvest.MultiplyChest("Grava", id, gd.GrimHarvest.killTable["Grava"].chest[1 + Game.GetGameDifficulty()])
		end
	},
	Kuba = {
		dbr = "records/creatures/enemies/nemesis/nemesis_beast_01_p1.dbr",
		count = 0,
		chest = {"grim_harvest/records/items/lootchests/n01_nemesischest_beast01.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_beast02.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_beast03.dbr"},
		quest = function(id)
			gd.nemesisGDX1.beastNemesisP03AKilled(id)
			gd.nemesisGDX1.beastNemesisP03BKilled(id)
			gd.nemesisGDX1.beastNemesisP03CKilled(id)
			gd.nemesisGDX1.beastNemesisP03DKilled(id)
			gd.GrimHarvest.MultiplyChest("Kuba", id, gd.GrimHarvest.killTable["Kuba"].chest[1 + Game.GetGameDifficulty()])
		end
	},
	Kaisan = {
		dbr = "records/creatures/enemies/nemesis/nemesis_eldritch_01.dbr",
		count = 0,
		chest = {"grim_harvest/records/items/lootchests/n01_nemesischest_eldritch01.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_eldritch02.dbr", "grim_harvest/records/items/lootchests/n01_nemesischest_eldritch03.dbr"},
		quest = function(id)
			gd.nemesisGDX2.eldritchNemesisKilled(id)
			gd.GrimHarvest.MultiplyChest("Kaisan", id, gd.GrimHarvest.killTable["Kaisan"].chest[1 + Game.GetGameDifficulty()])
		end
	},
}

gd.GrimHarvest.TargetFarmTable = {
	"records/creatures/enemies/livingplant_b01.dbr",
	"records/creatures/enemies/faction/necro_championf_c01.dbr",
	"records/creatures/enemies/basilisk_c01.dbr",
	"records/creatures/enemies/faction/zealot_championf_c01.dbr",
	"records/creatures/enemies/chthonianrylok_c01.dbr",
	"records/creatures/enemies/wendigo_b01.dbr",
	"records/creatures/enemies/human_ascended_c01.dbr",
	"records/creatures/enemies/humanoutlaw_aether_c01.dbr",
	"records/creatures/enemies/human_possessed_c01.dbr",
	"records/creatures/enemies/human_korvaak_b01.dbr",
	"records/creatures/enemies/trollhalfcorrupted_d01.dbr",
	"records/creatures/enemies/gargoyle_c01.dbr",
	"records/creatures/enemies/humanoutlaw_arsonist_c01.dbr",
	"records/creatures/enemies/eldritcharmor_c01.dbr",
	"records/creatures/enemies/humanoutlaw_murderer_c01.dbr",
	"records/creatures/enemies/human_possessed_b01.dbr",
	"records/creatures/enemies/humanchthonic_cultist_c02.dbr",
	"records/creatures/enemies/swampcrab_c01.dbr",
	"records/creatures/enemies/ghostcrab_c01.dbr",
	"records/creatures/enemies/trollhalf_cave_b01.dbr",
	"records/creatures/enemies/dermapteran_c01.dbr",
	"records/creatures/enemies/korvaakascended_c02.dbr",
	"records/creatures/enemies/wendigo_c01.dbr",
	"records/creatures/enemies/sandlizard_volcanic_c01.dbr",
	"records/creatures/enemies/sandlizard_eldritch_c01.dbr",
	"records/creatures/enemies/chthonianservitor_c01.dbr",
	"records/creatures/enemies/faction/cult_championf_c01.dbr",
	"records/creatures/enemies/viper_c01.dbr",
	"records/creatures/enemies/trollhalf_cave_b02.dbr",
	"records/creatures/enemies/prawn_c01.dbr",
	"records/creatures/enemies/eldritchwraith_c01.dbr",
	"records/creatures/enemies/groblee_shaman_b01.dbr",
	"records/creatures/enemies/grobled_shaman_b01.dbr",
	"records/creatures/enemies/groblesand_c02.dbr",
	"records/creatures/enemies/grobleb_shaman_b01.dbr",
	"records/creatures/enemies/groblec_shaman_b01.dbr",
	"records/creatures/enemies/groblea_shaman_b01.dbr",
	"records/creatures/enemies/yetiswamp_c01.dbr",
	"records/creatures/enemies/gazer_d01.dbr",
	"records/creatures/enemies/yeti_c01.dbr",
	"records/creatures/enemies/aetherialcolossus_c02.dbr",
	"records/creatures/enemies/obsidiandefiler_c01.dbr",
	"records/creatures/enemies/special/bonebleach_c01.dbr",
	"records/creatures/enemies/statue_c02.dbr.dbr",
	"records/creatures/enemies/celestialstatue_c02.dbr",
	"records/creatures/enemies/statuebasalt_c02.dbr",
	"records/creatures/enemies/chthoniandreadguard_c02.dbr",
	"records/creatures/enemies/aetherialsentry_b01.dbr",
	"records/creatures/enemies/ghost_b04.dbr",
	"records/creatures/enemies/trollhalfcorrupted_b02.dbr",
	"records/creatures/enemies/trollhalfcorrupted_b03.dbr",
	"records/creatures/enemies/faction/cult_ranged_a01.dbr",
	"records/creatures/enemies/swampgolem_c01.dbr"
}


function gd.GrimHarvest.OnAddToWorldChestUnlockedTier2(objectID)
	chest_tier2_unlocked_id = objectID
end

function gd.GrimHarvest.OnAddToWorldChestTier2(objectID)
	chest_tier2_id = objectID
end

function gd.GrimHarvest.OnAddToWorldChestLoghorrean(objectID)
	gd.quests.areaDQuestBaneOfCairn.lootChestOnAddToWorld(objectID)
	chest_loghorrean = objectID
end

function gd.GrimHarvest.OnAddToWorldChestTeodin(objectID)
	gd.quests.areaFFleshshaper.lootChestOnAddToWorld(objectID)
	chest_teodin = objectID
end

function gd.GrimHarvest.OnAddToWorldChestKorvaak(objectID)
	gd.quests.areaGKorvaak.lootChestOnAddToWorld(objectID)
	chest_korvaak = objectID
end

function gd.GrimHarvest.OnAddToWorldChestKraken(objectID)
	gd.quests.areaEQuestUgdenbog.krakenChestOnAddToWorld(objectID)
	chest_kraken = objectID
end

function gd.GrimHarvest.OnAddToWorldChestTombHeritic(objectID)
	chest_TofH = objectID
end

function gd.GrimHarvest.OnAddToWorldChestStepsTorment(objectID)
	chest_SoT = objectID
end

function gd.GrimHarvest.OnAddToWorldChestPortValbury(objectID)
	chest_PV = objectID
end

function gd.GrimHarvest.OnAddToWorldChestAncientGrove(objectID)
	chest_AG = objectID
end

function gd.GrimHarvest.OnAddToWorldChestBastionChaos(objectID)
	chest_BoC = objectID
end

function gd.GrimHarvest.MultiplyChest(key, objectID, dbr)
	if Server then
		if(objectID) then
			local object = Entity.Get(objectID)
			for spawn_n = 2, gd.GrimHarvest.killTable[key].count, 1 do
				local chest = Entity.Create(dbr)
				chest:SetCoords(object:GetCoords())
			end
		end
	end
end

function gd.GrimHarvest.RespawnTrio(key, id, count_a, count_b, count_c)
	if Server then
		local target = gd.GrimHarvest.killTable[key].count
		if(count_a > target and count_b > target and count_c > target) then
			gd.GrimHarvest.Respawn(key, id)
		end
	end
end

function gd.GrimHarvest.Respawn(key, id)
	if Server then
		local monster = gd.GrimHarvest.killTable[key]
		monster.count = monster.count + 1
		if (monster.count <= gd.GrimHarvest.killTreshold - gd.GrimHarvest.AdditionalBossSpawn - 1) then
			local coords = Entity.Get(id):GetCoords()
			local proxy = Proxy.Create(monster.dbr, coords.origin, true)
			proxy:SetCoords(coords)
		end
		if(monster.count >= gd.GrimHarvest.killTreshold and monster.quest ~= nil) then
			monster.quest(id)
		end
	end
end

function gd.GrimHarvest.MultiplyNemesis(key, id, level)
	if Server then
		local object = Entity.Get(id)
		if (object == nil or object:IsReloaded()) then
			return
		end
		if(gd.GrimHarvest.BossSpawnMultiplier == 0) then
			return
		end
		for spawn_n = 1, gd.GrimHarvest.AdditionalBossSpawn, 1 do
			gd.GrimHarvest.SpawnCharacter(key, id, level)
		end
	end
end

function gd.GrimHarvest.NemesisRespawn(key, id, level)
	if Server then
		local monster = gd.GrimHarvest.killTable[key]
		monster.count = monster.count + 1
		if (monster.count <= gd.GrimHarvest.killTreshold - gd.GrimHarvest.AdditionalBossSpawn - 1) then
			gd.GrimHarvest.SpawnCharacter(key, id, level)
		end
		if(monster.count >= gd.GrimHarvest.killTreshold and monster.quest ~= nil) then
			monster.quest(id)
		end
	end
end

function gd.GrimHarvest.SpawnCharacter(key, id, level)
	if Server then	
		local coords = Entity.Get(id):GetCoords()
		local spawn = Character.Create(gd.GrimHarvest.killTable[key].dbr, level, nil)
		spawn:SetCoords(coords)
	end
end

function gd.GrimHarvest.Multiply_Proxy(objectID)
	if Server then
		gd.GrimHarvest.Multiply(objectID, gd.GrimHarvest.AdditionalCrowdSpawn)
	end
end

function gd.GrimHarvest.Multiply_Boss_Proxy(objectID)
	if Server then		
		gd.GrimHarvest.Multiply(objectID, gd.GrimHarvest.AdditionalBossSpawn)
	end
end

function gd.GrimHarvest.Multiply(objectID, count)
	if Server then
		local object = Entity.Get(objectID)
		if (object == nil or object:IsReloaded()) then
			return
		end
		if(gd.GrimHarvest.BossSpawnMultiplier == 0) then
			return
		end
		local record = "grim_harvest/"..object:GetName()
		print(record)
		for spawn_n = 1, count, 1 do
			local proxy = Proxy.Create(record, object:GetCoords().origin, true)
			proxy:SetCoords(object:GetCoords())
		end
	end
end

function gd.GrimHarvest.MultiplyBossWithRecord(objectID, record)
	if Server then
		local object = Entity.Get(objectID)
		if (object == nil or object:IsReloaded()) then
			return
		end
		if(gd.GrimHarvest.BossSpawnMultiplier == 0) then
			return
		end
		print(record)
		for spawn_n = 1, gd.GrimHarvest.AdditionalBossSpawn, 1 do
			local proxy = Proxy.Create(record, object:GetCoords().origin, true)
			proxy:SetCoords(object:GetCoords())
		end
	end
end

function gd.GrimHarvest.OnPlayerSpawn(objectID)
	local player = Game.GetLocalPlayer()
	if(not player) then
		return
	end
	if(not player:HasItem("grim_harvest/skills/scroll_summon_harvester.dbr", 1, false)) then
		player:GiveItem("grim_harvest/skills/scroll_summon_harvester.dbr", 1, false)
	end
	if Server then
		for i=1,12,1 do
			if(player:HasToken(GH_Extra_Mobs..values[i])) then
				gd.GrimHarvest.AdditionalCrowdSpawn = values[i]
			end
			if(player:HasToken(GH_Extra_Boss..values[i])) then
				gd.GrimHarvest.AdditionalBossSpawn = values[i]
			end
			if(player:HasToken(GH_Extra_Respawn..values[i])) then
				gd.GrimHarvest.AdditionalBossRespawns = values[i]
			end
		end
		gd.GrimHarvest.CalculateKillTeshold()
	end
end

function gd.GrimHarvest.SpawnHarvester(objectID)
		local obj = Entity.Get(objectID)
		local npc = Entity.Create("grim_harvest/skills/grim_harvester.dbr")
		npc:SetCoords(obj:GetCoords())
end

function gd.GrimHarvest.SetGrimHarvestTokens(token, prev, new)
	if Server then
		local player = Game.GetLocalPlayer()
		if(player and player:HasToken(token..prev)) then
			player:RemoveToken(token..prev)
			print("REMOVING "..token..prev)
		end
		player:GiveToken(token..new)
		print("SETTING "..token..new)
	end
end

function gd.GrimHarvest.SetAddtionalCrowdSpawn(number)
	if Server then
		gd.GrimHarvest.SetGrimHarvestTokens(GH_Extra_Mobs, gd.GrimHarvest.AdditionalCrowdSpawn, number)
		gd.GrimHarvest.AdditionalCrowdSpawn = number
	end
end

function gd.GrimHarvest.SetAddtionalBossSpawn(number)
	if Server then
		gd.GrimHarvest.SetGrimHarvestTokens(GH_Extra_Boss, gd.GrimHarvest.AdditionalBossSpawn, number)
		gd.GrimHarvest.AdditionalBossSpawn = number
		gd.GrimHarvest.CalculateKillTeshold()
	end
end

function gd.GrimHarvest.SetAddtionalBossReSpawns(number)
	if Server then
		gd.GrimHarvest.SetGrimHarvestTokens(GH_Extra_Respawn, gd.GrimHarvest.AdditionalBossRespawns, number)
		gd.GrimHarvest.AdditionalBossRespawns = number
		gd.GrimHarvest.CalculateKillTeshold()
	end
end

function gd.GrimHarvest.RemoveAllTokens()
	if Server then
		local player = Game.GetLocalPlayer()
		if(not player) then
			return
		end
		for i=1,12,1 do
			if(player:HasToken(GH_Extra_Mobs..values[i])) then
				player:RemoveToken(GH_Extra_Mobs..values[i])
			end
			if(player:HasToken(GH_Extra_Boss..values[i])) then
				player:RemoveToken(GH_Extra_Boss..values[i])
			end
			if(player:HasToken(GH_Extra_Respawn..values[i])) then
				player:RemoveToken(GH_Extra_Respawn..values[i])
			end
		end
	end
end

function gd.GrimHarvest.ResetParameters()
	if Server then
		gd.GrimHarvest.RemoveAllTokens()
		gd.GrimHarvest.SetAddtionalCrowdSpawn(0)
		gd.GrimHarvest.SetAddtionalBossSpawn(0)
		gd.GrimHarvest.SetAddtionalBossReSpawns(0)
		gd.GrimHarvest.CalculateKillTeshold()
		gd.GrimHarvest.TargetFarmRecord = ""
	end
end

function gd.GrimHarvest.CalculateKillTeshold()
	if Server then
		gd.GrimHarvest.killTreshold = (gd.GrimHarvest.AdditionalBossRespawns + 1) * (gd.GrimHarvest.AdditionalBossSpawn + 1)
	end
end

function gd.GrimHarvest.GetLevel()
	local average_level = Game.GetAveragePlayerLevel()
	local monster_level = 0
	if(Game.GetGameDifficulty() == Game.Difficulty.Normal ) then
		monster_level = math.min(65, average_level)
	elseif (Game.GetGameDifficulty() == Game.Difficulty.Epic ) then
		monster_level = math.min(85, average_level) +3
	else
		monster_level = average_level + 9
	end
	return monster_level, nil
end

function gd.GrimHarvest.ReplaceSpawns(objectID)
	if Server then
		local obj = Entity.Get(objectID)
		if (obj == nil or gd.GrimHarvest.TargetFarmRecord == "") then
			return
		end
		local spawn = Character.Create( gd.GrimHarvest.TargetFarmRecord, gd.GrimHarvest.GetLevel(), nil)
		spawn:SetCoords(obj:GetCoords())
		obj:Destroy()
	end
end

function gd.GrimHarvest.SetTargetFarm(number)
	gd.GrimHarvest.TargetFarmRecord = gd.GrimHarvest.TargetFarmTable[number]
end

Script.Load("scripts/game/GrimHarvest/areas/proxy_multiplier_boss_n_quest.lua")
Script.Load("scripts/game/GrimHarvest/Bosses/respawn_act_1_bosses.lua")
Script.Load("scripts/game/GrimHarvest/Bosses/respawn_act_2_bosses.lua")
Script.Load("scripts/game/GrimHarvest/Bosses/respawn_act_3_bosses.lua")
Script.Load("scripts/game/GrimHarvest/Bosses/respawn_act_4_bosses.lua")
Script.Load("scripts/game/GrimHarvest/Bosses/respawn_act_5_bosses.lua")
Script.Load("scripts/game/GrimHarvest/Bosses/respawn_act_6_bosses.lua")
Script.Load("scripts/game/GrimHarvest/Bosses/respawn_act_7_bosses.lua")
Script.Load("scripts/game/GrimHarvest/Bosses/respawn_nemesis.lua")